#ifndef SMPubDataWrapper_WRAPPER_HEADER_H
#define SMPubDataWrapper_WRAPPER_HEADER_H

#include <time.h>
#include <sys_ctr.h>
#include <stddef.h>
#include <stdio.h>
#include "SMWrapper.hpp"
#include "pub/PubDataWrapper.h"
#include "dpc_sm/executable.h"
#ifdef __cplusplus
extern "C"
{
#endif

// C header here
#include "SM_Itg.h"

#ifdef __cplusplus
}
#endif

template <typename EventType>
class SM2Decision_PubDataWrapper : public PubDataWrapper<EventType>
{
private:
	dpc::SM4Decision _sm_data;

public:
	void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
	{
		data->sm_lfcmfrtavlbhvr = _sm_data.sm_lfcmfrtavlbhvr;
	}

	void SetData(const dpc::SM4Decision _data)
	{
		_sm_data.sm_lfcmfrtavlbhvr = _data.sm_lfcmfrtavlbhvr;
		_sm_data.sm_lfcmfrtavlbhvr_crdrid = _data.sm_lfcmfrtavlbhvr_crdrid;
		_sm_data.sm_lcavlbhvr = _data.sm_lcavlbhvr;
		_sm_data.sm_lcavlbhvr_crdrid = _data.sm_lcavlbhvr_crdrid;
		_sm_data.sm_lcpavlbhvr = _data.sm_lcpavlbhvr;
		_sm_data.sm_lcpavlbhvr_crdrid = _data.sm_lcpavlbhvr_crdrid;
		_sm_data.sm_lssavlbhvr = _data.sm_lssavlbhvr;
		_sm_data.sm_lgtavlbhvr = _data.sm_lgtavlbhvr;
		_sm_data.sm_sftystp = _data.sm_sftystp;
		_sm_data.sm_latactvfunc = _data.sm_latactvfunc;
		_sm_data.sm_drvmd = _data.sm_drvmd;
		_sm_data.sm_nrp_lcavl = _data.sm_nrp_lcavl;
		_sm_data.sm_drvr_indctdrct = _data.sm_drvr_indctdrct;
		_sm_data.sm_drvrsetspd = _data.sm_drvrsetspd;
		_sm_data.sm_seltdistlvl = _data.sm_seltdistlvl;
		_sm_data.sm_fdout_strgy_lat = _data.sm_fdout_strgy_lat;
		_sm_data.sm_fdin_strgy_lat = _data.sm_fdin_strgy_lat;
		_sm_data.sm_fdout_strgy_lgt = _data.sm_fdout_strgy_lgt;
		_sm_data.sm_fdin_strgy_lgt = _data.sm_fdin_strgy_lgt;
		_sm_data.sm_spdlmtid01 = _data.sm_spdlmtid01;
		_sm_data.sm_speedlimit01 = _data.sm_speedlimit01;
		_sm_data.sm_controlwaypoint_offset01 = _data.sm_controlwaypoint_offset01;
		_sm_data.sm_spdlmtid02 = _data.sm_spdlmtid02;
		_sm_data.sm_speedlimit02 = _data.sm_speedlimit02;
		_sm_data.sm_controlwaypoint_offset02 = _data.sm_controlwaypoint_offset02;
	}
};

#endif
